Summary: GNU C Compiler
Name: gcc
Version: 2.7.2
Release: 9
Copyright: GPL
Group: Development/Languages
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-2.7.2.tar.gz
Patch0: sunsite.unc.edu:/pub/Linux/GCC/gcc-2.7.2-linux.diff.gz
Patch1: gcc-2.7.2-make.patch
Patch2: gcc-2.7.2.sparc.patch
Patch3: ftp://atheist.tamu.edu/pub/richard/linux/axp/rth-gcc-2.7.2-960814.diff.gz
Patch4: gcc-2.7.2-pg.patch

%description
The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++ and 
Objective C compilers as well.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: gcc = 2.7.2

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Requires: gcc = 2.7.2
Summary: Objective C support for gcc
Group: Development/Languages

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%prep
%setup
%patch0 -p2
%patch1 -p1 -b .rh
%patch2 -p1
%patch3 -p1
%patch4 -p0

%build

%ifarch i386
./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ i486-linux
%endif
%ifarch axp
./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ alpha-linux
%endif
%ifarch sparc
./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ sparc-linux
%endif
make LANGUAGES=c
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

%install
rm -f /lib/cpp
rm -f /usr/info/gcc.info* /usr/info/cpp.info*
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s" install

# For Objective C only
make install-libobjc CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

gzip -n -9f /usr/info/gcc.info* /usr/info/cpp.info*

rm -f /usr/bin/cc
ln -sf gcc /usr/bin/cc
ln -sf cccp.1 /usr/man/man1/cpp.1

%ifarch i386
ln -sf ../usr/lib/gcc-lib/i486-linux/2.7.2/cpp /lib/cpp
%endif
%ifarch axp
ln -sf ../usr/lib/gcc-lib/alpha-linux/2.7.2/cpp /lib/cpp
%endif
%ifarch sparc
ln -sf ../usr/lib/gcc-lib/sparc-linux/2.7.2/cpp /lib/cpp
%endif

%files
%doc NEWS PROBLEMS

%dir /usr/lib/gcc-lib
%ifarch i386
%dir /usr/lib/gcc-lib/i486-linux/2.7.2
%dir /usr/lib/gcc-lib/i486-linux/2.7.2/include
%endif
%ifarch axp
%dir /usr/lib/gcc-lib/alpha-linux/2.7.2
%dir /usr/lib/gcc-lib/alpha-linux/2.7.2/include
%endif
%ifarch sparc
%dir /usr/lib/gcc-lib/sparc-linux/2.7.2
%dir /usr/lib/gcc-lib/sparc-linux/2.7.2/include
%endif

%ifarch i386
/usr/bin/i486-linux-gcc
%endif 
%ifarch axp
/usr/bin/alpha-linux-gcc
%endif
%ifarch sparc
/usr/bin/sparc-linux-gcc
%endif

/usr/bin/gcc
/usr/bin/cc
/usr/bin/protoize
/usr/bin/unprotoize

/lib/cpp

/usr/man/man1/cpp.1
/usr/man/man1/cccp.1
/usr/man/man1/gcc.1

/usr/info/cpp.info*
/usr/info/gcc.info*

%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/SYSCALLS.c.X
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1
/usr/lib/gcc-lib/i486-linux/2.7.2/cpp
/usr/lib/gcc-lib/i486-linux/2.7.2/libgcc.a
/usr/lib/gcc-lib/i486-linux/2.7.2/specs

/usr/lib/gcc-lib/i486-linux/2.7.2/include/README
/usr/lib/gcc-lib/i486-linux/2.7.2/include/float.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/iso646.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/limits.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/proto.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/stdarg.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/stddef.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/syslimits.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-alpha.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-clipper.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-h8300.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-i860.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-i960.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-m88k.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-mips.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-pa.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-pyr.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-sparc.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-spur.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/varargs.h
%endif

%ifarch sparc
/usr/lib/gcc-lib/sparc-linux/2.7.2/SYSCALLS.c.X
/usr/lib/gcc-lib/sparc-linux/2.7.2/cc1
/usr/lib/gcc-lib/sparc-linux/2.7.2/cpp
/usr/lib/gcc-lib/sparc-linux/2.7.2/libgcc.a
/usr/lib/gcc-lib/sparc-linux/2.7.2/specs
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/README
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/float.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/iso646.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/limits.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/proto.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/stdarg.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/stddef.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/syslimits.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-alpha.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-clipper.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-h8300.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-i860.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-i960.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-m88k.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-mips.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-pa.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-pyr.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-sparc.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/va-spur.h
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/varargs.h
%endif

%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/SYSCALLS.c.X
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1
/usr/lib/gcc-lib/alpha-linux/2.7.2/cpp
/usr/lib/gcc-lib/alpha-linux/2.7.2/crt*
/usr/lib/gcc-lib/alpha-linux/2.7.2/libgcc.a
/usr/lib/gcc-lib/alpha-linux/2.7.2/specs
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/README
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/float.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/iso646.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/limits.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/proto.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/stdarg.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/stddef.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/syslimits.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-alpha.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-clipper.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-h8300.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-i860.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-i960.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-m88k.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-mips.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-pa.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-pyr.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-sparc.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-spur.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/varargs.h
%endif

%files c++
/usr/man/man1/g++.1
/usr/bin/g++
/usr/bin/c++

%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1plus
%endif
%ifarch sparc
/usr/lib/gcc-lib/sparc-linux/2.7.2/cc1plus
%endif
%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1plus
%endif

%files objc
%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1obj
/usr/lib/gcc-lib/i486-linux/2.7.2/libobjc.a
/usr/lib/gcc-lib/i486-linux/2.7.2/include/objc
%endif
%ifarch sparc
/usr/lib/gcc-lib/sparc-linux/2.7.2/cc1obj
/usr/lib/gcc-lib/sparc-linux/2.7.2/libobjc.a
/usr/lib/gcc-lib/sparc-linux/2.7.2/include/objc
%endif
%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1obj
/usr/lib/gcc-lib/alpha-linux/2.7.2/libobjc.a
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/objc
%endif
